/* --------------------------------------------------------------------------
 *
 * ETK++ --- The Easy Toolkit for C++ programing
 * Copyright (C) 2004-2006, Anthony Lee, All Rights Reserved
 *
 * $COPYING
 *
 * File: Bitmap.h
 * Description: EBitmap --- a rectangular image for drawing
 * Warning: Unfinished.
 *
 * --------------------------------------------------------------------------*/

#ifndef __ETK_BITMAP_H__
#define __ETK_BITMAP_H__

#include <etk/interface/View.h>
#include <etk/render/Pixmap.h>

#ifdef __cplusplus /* Just for C++ */

class EGraphicsDrawable;

class _IMPEXP_ETK EBitmap : public EArchivable {
public:
	EBitmap(ERect bounds, bool acceptsViews = false);
	EBitmap(const EBitmap *bitmap, bool acceptsViews = false);
	EBitmap(const EPixmap *pixmap, bool acceptsViews = false);
	virtual ~EBitmap();

	e_status_t	InitCheck() const;
	bool		IsValid() const;

	ERect		Bounds() const;

private:
	friend class EView;

	euint32 fRows;
	euint32 fColumns;

	EGraphicsDrawable *fPixmap;
};

#endif /* __cplusplus */

#endif /* __ETK_BITMAP_H__ */

