#ifndef __ETK_CLASS_INFO_H__
#define __ETK_CLASS_INFO_H__

#ifdef __cplusplus /* Just for C++ */

#include <typeinfo>

#define e_class_name(ptr)		(ptr ? (typeid(*(ptr))).name() : (const char*)NULL)
#define e_cast_as(ptr, class)		(ptr ? dynamic_cast<class*>(ptr) : (class*)NULL)
#define e_is_kind_of(ptr, class)	(ptr ? e_cast_as(ptr, class) != NULL : false)
#define e_is_instance_of(ptr, class)	(ptr ? typeid(*(ptr)) == typeid(class) : false)

#endif /* __cplusplus */

#endif /* __ETK_CLASS_INFO_H__ */

