#ifndef __ETK_LOCKER_H__
#define __ETK_LOCKER_H__

#include <etk/support/SupportDefs.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK ELocker {
public:
	ELocker();
	virtual ~ELocker();

	bool		Lock();
	void		Unlock();
	e_status_t	LockWithTimeout(e_bigtime_t microseconds);

	eint64		CountLocks() const;
	bool		IsLockedByCurrentThread() const;

private:
	void		*fLocker;
};

#endif /* __cplusplus */

#endif /* __ETK_LOCKER_H__ */


