#ifndef __ETK_FIND_DIRECTORY_H__
#define __ETK_FIND_DIRECTORY_H__ 

#include <etk/storage/Path.h>

typedef enum {
	E_BOOT_DIRECTORY = 0,
	E_APPS_DIRECTORY,
	E_BIN_DIRECTORY,
	E_LIB_DIRECTORY,
	E_ETC_DIRECTORY,
	E_ADDONS_DIRECTORY,
	E_TEMP_DIRECTORY,

	E_USER_DIRECTORY = 1000,
	E_USER_CONFIG_DIRECTORY,
	E_USER_BIN_DIRECTORY,
	E_USER_LIB_DIRECTORY,
	E_USER_ETC_DIRECTORY,
	E_USER_ADDONS_DIRECTORY,
} e_directory_which;

#ifdef __cplusplus /* Just for C++ */

_IMPEXP_ETK e_status_t e_find_directory(e_directory_which which, EPath *path);

#endif /* __cplusplus */

#endif /* __ETK_FIND_DIRECTORY_H__ */

