#ifndef __ETK_ARCHIVABLE_H__
#define __ETK_ARCHIVABLE_H__

#include <etk/support/SupportDefs.h>
#include <etk/app/Message.h>

#ifdef __cplusplus /* Just for C++ */

class _IMPEXP_ETK EArchivable {
public:
	EArchivable();
	EArchivable(EMessage *from);
	virtual ~EArchivable();

	virtual e_status_t Archive(EMessage *into, bool deep = true) const;

	static EArchivable *Instantiate(EMessage *from);
};

_IMPEXP_ETK bool e_validate_instantiation(EMessage *from, const char *class_name);

#endif /* __cplusplus */

#endif /* __ETK_ARCHIVABLE_H__ */


